找出缺失和重复的数字 - (LeetCode)

前言

最近工作太忙了,周一到周五,画了5天的原型设计,看着原型设计我都准备要吐的节奏,新项目很多业务不熟悉,去问同事需求,网上找资料学习业务需求,更重要的是还要构思业务流程和界面展示,产品经理在团队中还是非常重要的活,但是产品经理干一天,估计要一个团队干一个月或者一年都不定。话归正题,今天的题目是一个道简单的算法题,题目如下:

题目

  1. 找出缺失和重复的数字 - (LeetCode)

给你一个下标从0 开始的二维整数矩阵 grid,大小为 n * n ,其中的值在 [1, n2] 范围内。除了 a 出现 两次 ,b 缺失 之外,每个整数都恰好出现一次 。

任务是找出重复的数字a 和缺失的数字 b 。

返回一个下标从 0 开始、长度为 2 的整数数组 ans ,其中 ans[0] 等于 a ,ans[1] 等于 b 。

示例 1:

复制代码
输入:grid = [[1,3],[2,2]]
输出:[2,4]
解释:数字 2 重复,数字 4 缺失,所以答案是 [2,4] 。

示例 2:

复制代码
输入:grid = [[9,1,7],[8,9,2],[3,4,6]]
输出:[9,5]
解释:数字 9 重复,数字 5 缺失,所以答案是 [9,5] 。

提示:

  • 2 <= n == grid.length == grid[i].length <= 50
  • 1 <= grid[i][j] <= n * n
  • 对于所有满足1 <= x <= n * n 的 x ,恰好存在一个 x 与矩阵中的任何成员都不相等。
  • 对于所有满足1 <= x <= n * n 的 x ,恰好存在一个 x 与矩阵中的两个成员相等。
  • 除上述的两个之外,对于所有满足1 <= x <= n * n 的 x ,都恰好存在一对 i, j 满足 0 <= i, j <= n - 1 且 grid[i][j] == x 。

解题思路

1、定义一个HashMap<Integer, Integer>作为数组的存储对象,选择HashMap就是为了方便通过key可以快速查找是否存在,另外value字段可以存储数字出现的次数。

2、遍历完毕数组,就可以得出整个数组的整体结构,通过HashMap可以value大于1则知道重复的数字。

3、接着需要处理缺失的数字了,通过最小值1开始,最大值则是遍历数组的总数,通过for循环判断HashMap是否存在,不存在则是缺失数字,本人用List<Integer>只是为了更方便处理,最后通过List转换为int\[\]数组返回。

代码

java 复制代码
class Solution {
    public int[] findMissingAndRepeatedValues(int[][] grid) {
        HashMap<Integer, Integer> map = new HashMap<>();
        int len = 0;
        for (int[] ints : grid) {
            for (int anInt : ints) {
                if (map.containsKey(anInt)) {
                    // 存在则返回+1
                    map.replace(anInt, map.get(anInt) + 1);
                } else {
                    // 不存在则+0
                    map.put(anInt, 1);
                }
                len++;
            }
        }
        List<Integer> ansList = new ArrayList<>();
        for (Map.Entry<Integer, Integer> entry : map.entrySet()) {
            if (entry.getValue() > 1) {
                // 重复值
                ansList.add(entry.getKey());
            }

        }
        for (int i = 1; i <= len; i++) {
            if (!map.containsKey(i)) {
                // 不存在值,缺失值
                ansList.add(i);
            }
        }
        int[] ans = new int[ansList.size()];
        int idx = 0;
        for (Integer num : ansList) {
            ans[idx] = num;
            idx++;
        }
        return ans;
    }
}

今天这道题很轻松,接着后面的会比较忙碌的开始,自己也争取多点时间去了解更多数据结构和算法,不断学习和提高自己。

对了,明天就是六一儿童节了,虽然自己已经是四百多个月的大孩子了,但还是喜欢小时候的童年生活,简单,淳朴而快乐,在此祝各位大孩子们节日快乐!

相关推荐
拓恒技术7 小时前
无人机巡检AI算法的工程化落地:从需求到交付的5个核心环节
人工智能·算法·无人机
晨曦中的暮雨7 小时前
限流算法——固定窗口、滑动窗口、漏桶、令牌桶
java·开发语言·算法
怕浪猫7 小时前
Claude Code vs Codex:Computer Use 实现原理深度拆解
算法·面试·github
文丑颜不良啊8 小时前
LeetCode876~900题目解析
java·leetcode
罗西的思考9 小时前
AI 时代的 “房谋杜断”:如何培养能力、品味与判断力
人工智能·算法·机器学习
淡海水9 小时前
07-02-源码-.NET Core GC分配路径
算法·unity·c#·.netcore·gc·1024程序员节
下一站春风里11 小时前
位运算完整学习笔记:按位与(&)+ 异或(^)
开发语言·c++·算法
DRobot11 小时前
【机械制图与CAD实战(二十五)】螺纹的表示方法
算法·机械制图
用户老李11 小时前
卡尔曼滤波自学教程 10:无迹卡尔曼滤波(UKF)
算法
深圳市益普科技有限公司13 小时前
半导体良率管理YMS:良率与设备参数的相关性,先拉哪几组数据
人工智能·python·算法